// Agent auctioneer in project auction_ag

/* Initial beliefs and rules */

/* Initial goals */
!start.
/* Plans */

+!start : .my_name(Name) <-
      .wait(10000); .print("starting");
       +plays(initiator);
       .broadcast(tell,plays(initiator));
       !launch_auctions;
       .

+!launch_auctions : .findall(participant(A),plays(participant)[source(A)],L) & .length(L,Length) & Length >= 2
       <-
       .print("starting auction with ",L);
       !!cfp(pa,flight_ticket(paris, athens,"15/12/2016"),"now + 10 seconds");
       !cfp(ap,flight_ticket(athens, paris,"18/12/2016"),"now + 12 seconds").

-!launch_auctions
       <- .wait(500); !launch_auctions.

+!cfp(Id,Service, Time) : true <-
      makeArtifact(Id, "auction_env.AuctionArtifact", [], ArtId);
      .print("Auction artifact created for ",Service);
      Id::focus(ArtId);  // place observable properties of this auction in a particular name space
      .broadcast(achieve,focus(Id));  // ask all others to focus on this new artifact
      Id::start(Service);
      .at(Time, {+!decide(Id)}).

+!decide(Id)     // receives bids and checks for new winner
       <- Id::stop.

+NS::winner(W)[artifact_id(AId)] : W \== no_winner
      <- ?NS::task(S);
          ?NS::best_bid(V);
          .print("Winner for ", S, " is ",W," with ", V).

{ include("$jacamoJar/templates/common-cartago.asl") }
{ include("$jacamoJar/templates/common-moise.asl") }

// uncomment the include below to have a agent that always complies with its organization
//{ include("$jacamoJar/templates/org-obedient.asl") }
